#include <time.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#define N 1000
#define EMPTY -1

struct pel
{
	int key;
	pel *next;
};
pel *table[N];

void rInsert(pel *T[], int x);
void rInit();
pel *rSearch(pel *T[], int x);
void rDelete(pel *T[], int x);
void rPrintHash(pel *T[]);

void pInit(void);
int pInsert(int key);
int pFetch(int key);
int Hash(int key);

int tabl[N];			//
int keys[N];

//--------
void main(void)
{
	clrscr();
//------------------------
	rInit();
//	printf("Source data: ");
	for(unsigned long i=0;i<N;i++)
	{       keys[i]=random(N);
		rInsert(table,keys[i]);
//		printf(" %i",keys[i]);
	}
	printf("\n");
//	rPrintHash(table);
	unsigned long far *uk=(unsigned long far *)0x0040006C;
	unsigned long start, end;
	const unsigned long Tms=100000;
	printf("\n७ %lu ࠧ ==> %i ⮢",Tms,N);
	start = *uk;
	for (i=0;i<Tms;i++)
	{	rSearch(table,i%100);
//		printf(" %5i",i);
	}
	end=*uk;
	unsigned long t1=end-start;
	printf("\n஢ ࠧ묨 楯窠:\n६ ᪠ -> %5.15f ᥪ㭤  \n",(end-start)/18.2/Tms);
	printf("६ ᪠ -> %i ⨪()",(end-start));
	printf("  ७ %lu ࠧ\n",Tms);
	for(i=0;i<N;i++)
		rDelete(table,keys[i]);
//------------------------
	pInit();
	for (i=0;i<N;i++)
		pInsert(keys[i]);
	start = *uk;
	for (i=0;i<Tms;i++)
		pFetch(i%100);
	end = *uk;
	unsigned long t2=end-start;
	printf("\n ஢:\n६ ᪠ -> %5.15f ᥪ㭤  \n",(end-start)/18.2/Tms);
	printf("६ ᪠ -> %i ⨪()",end-start);
	printf("  ७ %lu ࠧ\n",Tms);
	getch();
	printf(" ஢  ࠡ⠥ ஢  ࠧ묨 楯窠  %i ࠧ\n",t2/t1);
}
//--------
pel *rSearch(pel *T[], int x)
{
	int key=Hash(x);
	pel *temp=T[key];
	if (!temp)
		return NULL;
	while((temp->key!=x)&&(temp->next))
		temp=temp->next;
	if (temp->key!=x)
		return NULL;
	return temp;
}
void rPrintHash(pel *T[])
{
	printf("\n");
	for (int i=0;i<N;i++)
	{
		if (!T[i])
			printf("null\n");
		else
		{
			printf("T[%02i]->",i);
			pel *temp=T[i];
			do
			{
				printf("%03i->",temp->key);
				temp=temp->next;
			}while(temp);
			printf("null\n");
		}
	}
}
int Hash(int key)
{
	return (key%N);
}
void rInit()
{
	for (int i=0;i<N;i++)
		table[i]=NULL;
}
void rInsert(pel *T[], int x)
{
	int key=Hash(x);
	pel *temp=new pel;
	temp->next=NULL;
	temp->key=x;
	if (!T[key])
		T[key]=temp;
	else
	{
		temp->next=T[key];
		T[key]=temp;
	}
}
void rDelete(pel *T[],int x)
{
	int key=Hash(x);
	pel *temp=T[key];
	if (!temp)
		printf("Element ""%02i"" does not exist\n",x);
	if (temp->key==x)
	{
		T[key]=temp->next;
		delete temp;
		return;
	}
	do
	{	if (temp->next->key==x)
			break;
		temp=temp->next;
	}while(temp->next->next);

	if (temp->next->key==x)
	{
		pel *p=temp->next;
		temp->next=p->next;
		delete p;
	}
	else
		printf("Element ""%02i"" does not exist\n",x);
}

void pInit(void)
{
	for(int i=0;i<N;i++)
		tabl[i]=EMPTY;
}
int pInsert(int key)
{
	int addr,a1;
	addr=Hash(key);
	if (tabl[addr]!=EMPTY)
	{
		a1=addr;
		do
		{
			addr=Hash(addr+1);
		}while(!((addr==a1)||(tabl[addr]==EMPTY)));
		if (tabl[addr]!=EMPTY)
			return 0;
	}
	tabl[addr]=key;
	return 1;
}
int pFetch(int key)
{
	int addr, a1;
	addr=Hash(key);
	if (tabl[addr]==EMPTY)
		return EMPTY;			//        
	else
		if (tabl[addr]==key)
			return addr;		//    
		else     				//   
		{	a1=Hash(addr+1);
			//,          
			while((tabl[a1]!=key)&&(a1!=addr))
				a1=Hash(a1+1);

			if (tabl[a1]!=key)
				return EMPTY;
			else
				return a1;
		}
}
