#include <time.h>
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>

#define N 15
#define EMPTY -1

struct pel
{
	int key;
	pel *next;
};
pel *table[N];

void Insert(pel *T[], int x);
void Init();
pel *Search(pel *T[], int x);
void Delete(pel *T[], int x);
void PrintHash(pel *T[]);
int Hash(int key);

int keys[N]={58,0,75,19,96,38,81,52,66,62,77,4,15,79,100};

//--------
void main(void)
{
	clrscr();
	Init();
	printf("Source data: ");
	for(unsigned long i=0;i<N;i++)
	{	Insert(table,keys[i]);
		printf(" %i",keys[i]);
	}
	printf("\n");
	PrintHash(table);
	for (i=0;i<N;i++)
		Search(table,keys[i]);
	for(i=0;i<N;i++)
		Delete(table,keys[i]);
}
//--------
pel *Search(pel *T[], int x)
{
	int key=Hash(x);
	pel *temp=T[key];
	if (!temp)
		return NULL;
	while((temp->key!=x)&&(temp->next))
		temp=temp->next;
	if (temp->key!=x)
		return NULL;
	return temp;
}
void PrintHash(pel *T[])
{
	printf("\n");
	for (int i=0;i<N;i++)
	{
		if (!T[i])
			printf("null\n");
		else
		{
			printf("T[%02i]->",i);
			pel *temp=T[i];
			do
			{
				printf("%03i->",temp->key);
				temp=temp->next;
			}while(temp);
			printf("null\n");
		}
	}
}
int Hash(int key)
{
	return (key%N);
}
void Init()
{
	for (int i=0;i<N;i++)
		table[i]=NULL;
}
void Insert(pel *T[], int x)
{
	int key=Hash(x);
	pel *temp=new pel;
	temp->next=NULL;
	temp->key=x;
	if (!T[key])
		T[key]=temp;
	else
	{
		temp->next=T[key];
		T[key]=temp;
	}
}
void Delete(pel *T[],int x)
{
	int key=Hash(x);
	pel *temp=T[key];
	if (!temp)
		printf("Element ""%02i"" does not exist\n",x);
	if (temp->key==x)
	{
		T[key]=temp->next;
		delete temp;
		return;
	}
	do
	{	if (temp->next->key==x)
			break;
		temp=temp->next;
	}while(temp->next->next);

	if (temp->next->key==x)
	{
		pel *p=temp->next;
		temp->next=p->next;
		delete p;
	}
	else
		printf("Element ""%02i"" does not exist\n",x);
}