#include <iostream.h>
#include <fstream.h>
#include <conio.h>
#include <dos.h>
#include <string.h>
#include <time.h>
#define __n 20
#define __m 4
#define NN 1000000
//================================
struct THTItem{
  int Key;
  int Index;
};//THTItem
//================================
struct TInfo{
  char Num[__m];
  int  Date;
  char Name[__n];
  char Mark;
};//TInfo
//================================
struct TItem{
    TInfo  Item;
    TItem* Next;
};//TItem
//================================
class TTable{
  protected:
	   unsigned long         Count;
	   TItem*     	         pFirst;
	   TItem*	         pTmp;
	   void                  MoveTo(unsigned long Index);
	 public:
				 TTable();
	   void                  LoadFromFile(char* Path);
	   void                  Insert(TInfo, unsigned long Index);
	   void                  Delete(unsigned long Index);
	   virtual void          Print(void);
	   unsigned long         Append(TInfo Item);
	   virtual unsigned long GetCount();
	   virtual void          SetItem(TInfo Item, unsigned long Index);
	   virtual TInfo         GetItem(unsigned long Index);
	   unsigned int          Find(char Key[__n]);
				 ~TTable(void);
};//TTable
//================================
class THash {
  protected:
    THTItem* HT;
    int      size;
  public:
		  THash(int Size);
    unsigned int  Hash(int Key);
    unsigned int  Hash(char Key[__n]);
    int           Set(char Key[__n], int Index);
    int           Get(char Key[__n]);
    void          Print();
		  ~THash();
};//THash
//================================
class THashedTable : public TTable{
  public:
    THash* HT;
    THashedTable(char* Path);
    void Print();
    ~THashedTable();
};//THashedTable
//=================================
THashedTable::THashedTable(char* path){
  this->TTable::LoadFromFile(path);
  HT = new THash(this->TTable::GetCount());
  for(int i = 0; i < this->GetCount(); i++){
    TInfo inf = this->GetItem(i+1);
    HT->Set(inf.Name, i+1);
  };//for

};//THashedTable::THashedTable()
//---------------------------------
THashedTable::~THashedTable(){
  delete HT;
};//THashedTable::~THashedTable()
//---------------------------------
void THashedTable::Print(void){
  for(int i = 1; i <= this->GetCount(); i++){
    TInfo Item = this->GetItem(i);
    cout << Item.Num  << "\t";
    int j = 0;
    while(Item.Name[j])
      cout << Item.Name[j++];
    for(int k = j; k < __n; cout << " ", k++);
    cout << "\t" << Item.Mark << "\t";
    cout << HT->Hash(Item.Name) << endl;
  };//for
};//void THashedTable::Print(void)
//---------------------------------
TTable::TTable(){
  Count        = 0;
  pFirst       = new TItem;
  pTmp         = new TItem;
  pFirst->Next = 0;
  pTmp         = 0;
};//TTable::TTable()
//--------------------------------
TTable::~TTable() {
  while(pFirst) {
    pTmp   = pFirst;
    pFirst = pFirst->Next;
    delete pTmp;
  };//while
  delete pFirst;
};//TTable::~TTable()
//--------------------------------
unsigned long TTable::GetCount() {
  return Count;
};//unsigned long TTable::GetCount()
//--------------------------------
void TTable::MoveTo(unsigned long Index){
  pTmp = pFirst;
  for(register unsigned long i = 1; i <= Index; pTmp = pTmp->Next, i++);
};//TTable::MoveTo(unsigned long Index)
//--------------------------------
unsigned long TTable::Append(TInfo Item) {
  MoveTo(Count);
  pTmp->Next       = new TItem;
  pTmp->Next->Item = Item;
  pTmp->Next->Next = 0;
  return ++Count;
};//unsigned long TTable::Append(TInfo Item)
//--------------------------------
void TTable::Insert(TInfo Item, unsigned long Index){
  if(Index > Count + 2)
    return;
  if(Index == Count + 1){
    Append(Item);
    return;
  };//if
  TItem*    temp = new TItem;
  temp->Item     = Item;
  MoveTo(Index - 1);
  temp->Next         = pTmp->Next;
  pTmp->Next         = temp;
  Count++;
  return;
};//void TTable::Insert(TInfo Item, unsigned long Index){
//--------------------------------
void TTable::Delete(unsigned long Index) {
  if((Index > Count) || (Index == 0))
    return;
  MoveTo(Index--);
  TItem* temp    = new TItem;
  temp           = pTmp->Next;
  pTmp->Next     = temp->Next;
  delete temp;
  temp = 0;
};//void TTable::Delete(unsigned long Index)
//--------------------------------
void TTable::SetItem(TInfo Item, unsigned long Index) {
 if ((Index > 0)&&(Index <= Count)) {
   MoveTo(Index);
   pTmp->Item = Item;
 };//if
};//void TTable::SetItem(TInfo Item, unsigned long Index)
//--------------------------------
TInfo TTable::GetItem(unsigned long Index) {
  if ((Index > 0) && (Index <= Count))
    MoveTo(Index);
  return pTmp->Item;
};//TInfo TTable::GetItem(unsigned long Index)
//--------------------------------
void TTable::LoadFromFile(char* Path){
  ifstream ifs(Path);
  TInfo inf;
  while(ifs){
    ifs >> inf.Num;
    ifs >> inf.Name;
    ifs >> inf.Mark;
    inf.Date = 0;
    Append(inf);
  };//while
  ifs.close();
};//void TTable::LoadFromFile(char* Path)
//--------------------------------
void TTable::Print(){
  for(unsigned i = 1; i < Count; i++){
    MoveTo(i);
    cout << pTmp->Item.Num  << "\t";
    int j = 0;
    while(pTmp->Item.Name[j])
      cout << pTmp->Item.Name[j++];
    for(int k = j; k < __n; cout << " ", k++);
    cout << "\t" <<
	    pTmp->Item.Mark << "\n";
  };//for
};//void TTable::Print()
//--------------------------------
unsigned int TTable::Find(char Key[__n]){
 pTmp = pFirst->Next;
 int i = 1;
 while(pTmp){
   if(!strcmp(pTmp->Item.Name, Key))
     return i;
   i++;
   pTmp = pTmp->Next;
 };//while
 return 0;
};//unsigned int TTable::Find(char Key[__n])
//--------------------------------
THash::THash(int Size){
  HT = new THTItem[size = Size*4];
  for(register int i = 0; i < size; i++){
    HT[i].Key   = -1;
    HT[i].Index = 0;
  };//for
};//THash::THash(int Size)
//--------------------------------
THash::~THash(){
  delete HT;
};//THash::~THash()
//--------------------------------
unsigned int THash::Hash(int Key){
  return Key % (size + 1);
};//THash::Hash(int Key)
//--------------------------------
unsigned int THash::Hash(char Key[__n]){
  unsigned int key = 0;
  register int i = 0;
  while(Key[i])
    key += int(Key[i++]);
  //cout << this->Hash(key) << endl;
  return this->Hash(key);
};//int THash::Hash(char Key[__n])
//--------------------------------
int THash::Set(char Key[__n], int Index){
  int ad, adr, k;
  ad = adr = k = Hash(Key);
  if(HT[adr].Key == -1){
    HT[adr].Key = k;
    HT[adr].Index = Index;
    return adr;
  }//if
  else{
    do
      adr++;
    while ((ad != adr) && (HT[adr].Key != -1));
    if(HT[adr].Key == -1){
      HT[adr].Key = k;
      return adr;
    };//if
  };//else
  return -1;
};//int THash::Set(char Key[__n])
//--------------------------------
int THash::Get(char Key[__n]){
  int ad, adr, k;
  ad = adr = k = Hash(Key);
  if(HT[adr].Key == -1)
    return -1;
  else
    if(HT[adr].Key == k)
      return HT[adr].Index;
    else {
      do
	adr++;
      while ((ad != adr) && (HT[adr].Key != k));
      if(HT[adr].Key == k)
	return HT[adr].Index;
    };//else
  return -1;
};//int THash::Get(char Key[__n])
//--------------------------------
void THash::Print(){
  for(int i = 0; i < size; cout << HT[i].Key << " " << HT[i++].Index << endl );
  cout << "\n";
};//void THash::Print()
//--------------------------------
void main(){
  clrscr();
  cout << "஢\n";
  delay(1000);
  int     ind;
  long    i;
  TTable  tab;
  char    Name[20];
  clock_t beg;
  clock_t end;

  tab.LoadFromFile("Input.dat");
  THashedTable HT("Input.dat");
  HT.Print();

  cout << "\nName > ";
  cin >> Name;
  beg = clock();
  for(i = 0; i < NN; i++)
    ind = HT.HT->Get(Name);
  end = clock();

  TInfo inf = HT.GetItem(ind);
  cout << endl     << "Hash  : "<< inf.Num << "\t" << inf.Name << "\t"
       << inf.Mark << " TIME : " << end - beg << endl;

  beg = clock();
  for(i = 0; i < NN; i++)
    ind = tab.Find(Name);
  end = clock();

  inf = tab.GetItem(ind);
  cout << "Table : " << inf.Num << "\t" << inf.Name << "\t"
       << inf.Mark   << " TIME : " << end - beg << endl;
  cout << "\nPress any key to exit...\n";
  getch();
};//main